#include <stdio.h>
#include <Xm/Xm.h>
#include <X11/cursorfont.h>
#include "HTML2.h"
#include <fcntl.h>


Cursor gotocursor;

static Widget toplevel, test;
static XtAppContext app_context;
static XtInputId ipid;

static String fallback_resources[] =
{
    "HTML2T.geometry: 375x400",
    "HTML2T*background:	#ffffd6",

    /* Style sheet */
    /* "*textbackground: transparent", */
    "*style:\
*id: !ID\\n\
*language: !LANG\\n\
*target: !ID\\n\
HTML.leftindent: 1.0\\n\
HTML.rightindent: 1.0\\n\
HTML.justify: left\\n\
*H1.size: +2\\n\
*H1.bold: true\\n\
*H1.justify: center\\n\
*H1.rulebefore: 1.0\\n\
*H1.ruleafter: 1.0\\n\
*H1.prebreak: 2.0\\n\
*H1.postbreak: 1.0\\n\
*H1.noindent: false\\n\
*H2.size: +1\\n\
*H2.bold: true\\n\
*H2.justify: left\\n\
*H2.rulebefore: 0.3\\n\
*H2.prebreak: 1.0\\n\
*H2.postbreak: 1.0\\n\
*H2.leftindent: -3.0\\n\
*H2.parindent: 0.0\\n\
*H2.noindent: false\\n\
*H3.size: +1\\n\
*H3.justify: left\\n\
*H3.prebreak: 1.0\\n\
*H3.postbreak: 1.0\\n\
*H3.leftindent: -3.0\\n\
*H3.parindent: 0.0\\n\
*H3.noindent: false\\n\
*H4.bold: true\\n\
*H4.justify: left\\n\
*H4.prebreak: 1.0\\n\
*H4.postbreak: 0.5\\n\
*H4.parindent: 0.0\\n\
*H4.noindent: false\\n\
*H5.bold: true\\n\
*H5.prebreak: 1.0\\n\
*H5.parindent: 0.0\\n\
*H6.prebreak: 1.0\\n\
*H6.parindent: 0.0\\n\
*P.parindent: 2.0\\n\
*P.postbreak: 0.0\\n\
*U.underscore: 1\\n\
*S.strikeout: true\\n\
*TT.family: tt\\n\
*B.bold: true\\n\
*I.slant: true\\n\
*BIG.size: 1\\n\
*SMALL.size: -1\\n\
*EM.emphasis: 1\\n\
*STRONG.emphasis: 2\\n\
*CODE.family: alt\\n\
*CODE.size: -1\\n\
*SAMP.family: tt\\n\
*KBD.family: tt\\n\
*KDB.underscore: 1\\n\
*VAR.slant: true\\n\
*CITE.slant: true\\n\
*BR.empty: true\\n\
*BR.prebreak: 0.0\\n\
*BR.flush: !CLEAN\\n\
*BR.noindent: True\\n\
*WBR.empty: True\\n\
*WBR.insertbefore: &sbsp;\\n\
*A.textcolor: blue\\n\
*A.underscore: 0\\n\
*A.anchor: !HREF\\n\
*A.target: !NAME\\n\
*IMG.empty: true\\n\
*IMG.inline: !SRC\\n\
*IMG.valign: !ALIGN\\n\
*IMG.track: !ALIGN\\n\
*IMG.ismap: @ifmatch(!ISMAP, \"ISMAP\", true, false)\\n\
*IMG.width: !WIDTH\\n\
*IMG.height: !HEIGHT\\n\
*HR.empty: true\\n\
*HR.prebreak: 0.5\\n\
*HR.rulebefore: 0.0\\n\
*HR.postbreak: 0.0\\n\
*PRE.prebreak: 0.5\\n\
*PRE.postbreak: 0.5\\n\
*PRE.family: tt\\n\
*PRE.justify: left\\n\
*PRE.width: !WIDTH\\n\
*PRE.obeyspaces: true\\n\
*DL.prebreak: 1.0\\n\
*DL.postbreak: 1.0\\n\
*DL.leftindent: 2.0\\n\
*DT.prebreak: 0.5\\n\
*DT.parindent: -2.0\\n\
*DT.bold: true\\n\
*DT.insertafter:  \\n\
*DD.postbreak: 0.5\\n\
*OL.prebreak: 1.0\\n\
*OL.postbreak: 1.0\\n\
*OL.leftindent: 2.0\\n\
*UL.prebreak: 1.0\\n\
*UL.postbreak: 1.0\\n\
*UL.leftindent: 2.0\\n\
*LI.prebreak: 0.5\\n\
*LI.postbreak: 0.5\\n\
*OL.LI.label: 1\\n\
*OL*OL.LI.label: A\\n\
*OL*OL*OL.LI.label: I\\n\
*LI.label: bullet",

    NULL,
};

static String txt = "\
<H1>Test program for the HTML widget</H1>\n\
\n\
<P>Call this program with a <B>file name</B> as argument\n\
or with `-' for standard input.\n\
\n\
<P>If the file contains HTML-like tags, such as\n\
<TT>&lt;H1&gt</TT>, <TT>&lt;P&gt;</TT> and <TT>&lt;EM&gt;</TT>, they will\n\
be formatted according to the style sheet resource.\n\
";


static void get_file_input(client_data, fid, id)
XtPointer client_data;
int *fid;
XtInputId *id;
{
    char buf[BUFSIZ];
    int nbytes, i;

    if ((nbytes = read(*fid, buf, BUFSIZ)) == -1)
	perror("get_file_input");
    else
	XfwfAddText((Widget) client_data, buf, nbytes);
    if (nbytes==0) XtRemoveInput(ipid);
}


static void activate(Widget w, XtPointer call_data, XfwfFTextCallbackStruct *cd)
{
XfwfSSGMLData *p = cd->data;

fprintf(stderr,"Activate! p=%lx\n",p);
fprintf(stderr,"URL: %s\n",p->url);
fprintf(stderr,"ismap=%d\n",p->ismap);
}

static void resolve(Widget w, XtPointer call_data, XfwfResolveRec *cd)
{
fprintf(stderr,"Resolve!\n");
fprintf(stderr,"URL: %s\n",cd->url);
//fprintf(stderr,"data: %s\n",cd.data);
//fprintf(stderr,"length=%d\n",cd.length);
//fprintf(stderr,"method=%d\n",cd.method);
}


void main(int argc, String *argv)
{
    int fd;

    toplevel = XtVaAppInitialize(&app_context, "HTML2T", NULL, 0,
				 &argc, argv, fallback_resources, NULL);

    gotocursor = XCreateFontCursor(XtDisplay(toplevel), XC_hand2);

    test = XtVaCreateManagedWidget("Help", xfwfHTML2WidgetClass, toplevel,
		XtNactiveCursor, gotocursor,
		NULL);

    XtAddCallback(test, XtNactivate, activate, NULL);
    XtAddCallback(test, XtNresolveURL, resolve, NULL);
    XtRealizeWidget(toplevel);
    if (argc < 2) {
	XfwfAddText(test, txt, strlen(txt));
	XfwfAddText(test, NULL, 0);
    } else if (strcmp(argv[1], "-") == 0) {
	fd = fileno(stdin);
    } else if ((fd = open(argv[1], O_RDONLY)) == -1) {
	perror(argv[1]);
	exit(1);
    } else {
	ipid = XtAppAddInput(app_context, fd, (XtPointer) XtInputReadMask,
		      get_file_input, test);
    }
    XtAppMainLoop(app_context);
}
