/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */
#include <X11/Xos.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include "xmap.h"
#include "debug.h"

static void watchdog();
static void heartbeat();

XtAppContext app;


static XtIntervalId id1, id5;


static void heartbeat()
{
    // we know that the watchdog is ticking! So kill and restart.
    XtRemoveTimeOut(id5);
    id5 = XtAppAddTimeOut(app, 5000L, (XtTimerCallbackProc) watchdog, NULL);

    // now restart our own timer.
    id1 = XtAppAddTimeOut(app, 1000L, (XtTimerCallbackProc) heartbeat, NULL);

    do_conversions();
    do_monitor();
    update_instruments();
    update_route_info();
    finish_updates();
}

static void watchdog()
{
    error("Heartbeat stopped! Restarted by watchdog.",0);
    id1 = XtAppAddTimeOut(app, 1000L, (XtTimerCallbackProc) heartbeat, NULL);
    id5 = XtAppAddTimeOut(app, 5000L, (XtTimerCallbackProc) watchdog, NULL);
}

void start_heartbeat()
{
    id1 = XtAppAddTimeOut(app, 1000L, (XtTimerCallbackProc) heartbeat, NULL);
    id5 = XtAppAddTimeOut(app, 5000L, (XtTimerCallbackProc) watchdog, NULL);
} 
